#!/usr/bin/python -tt
## -*- coding: UTF-8 -*-

##############################################################################################
#                        ОПИСАНИЕ                                                            #
#                                                                                            #
# Этот скрипт предназначен для подсчёта количества использования различных                   #
# переменных при построении деревьев классификации путём обработки файла                     #
# trees.txt или любого другого текстового файла, полученного при помощи                      #
# прогона скрипта R, выложенного                                                             #
# на http://gis-lab.info/qa/classify-trees-r.html                                            #
#                                                                                            #
##############################################################################################
#                     ИСПОЛЬЗОВАНИЕ                                                          #
#                                                                                            #
# Распакуйте архив со скриптом в папку с обрабатываемым лог-файлом.                          #
# В командной строке введите: './trees.py <обрабатываемый файл> <файл для записи результата>'#
# например: './trees.py trees.txt varcount.csv'                                              #
# Если файла для записи результатов обработки не существует, то он будет создан              #                                           
# во время работы скрипта. Используйте скрипт на свой страх и риск: автор за последствия     #
# ответственности не несёт ;-)                                                               #
#                                                                                            #
##############################################################################################
#  АВТОР: S.S. Rebelious  http://gis-lab.info/forum/memberlist.php?mode=viewprofile&u=7619   #
#  ЛИЦЕНЗИЯ: СС0 (http://creativecommons.org/choose/zero/?lang=ru)                           #
##############################################################################################





import sys
import re


def dict_file(filename, write_file):
  line_list = []
  tree_list = []
  diction = {}
  input_file = open(filename, 'rU')
  for line in input_file:
    match = re.search(r'\w\w\w\s\w\w\w\s\d\d\s\d\d:\d\d:\d\d\s\d\d\d\d', line) # we are looking for timestamps like this: '[1] "Fri Aug 17 20:31:39 2012"'
    if match:
      pass #print "trash found"
    elif line[:3] == '[1]':
      line_list.append(line.replace('\"', '').replace('[1]', '').split())
    else:
      pass
  input_file.close()
  t = line_list[0]
  line_list.remove(t)
  for lis in line_list:
    while len(lis):
      tree_list.append(lis.pop(0))
  for x in tree_list:
    if not x in diction:
      diction[x] = tree_list.count(x)
    else: 
      pass
  #print 'dict:', line_list, 'tree_list:', tree_list, "diction:", diction
  order = sorted(diction.items(), reverse=True)
  #print order
  wf = open(str(write_file), 'w')
  wf.write("VAR,COUNT\n")
  for i in order:  
    y1 = str(i[0])  
    y2 = str(i[1]) 
    wf.write(y1)
    wf.write(',')
    wf.write(y2)
    wf.write('\n')
  wf.close()
  per = '%'
  import random
  ran = random.randint(1, 99)
  if filename != write_file:
    print 'DONE!\nAlso there is a %d%s chace that your data left intact ;-)' % (ran, per)
  else:
    print 'DONE!\nNote that there is a 0%s chace that your data left intact (T_T)' % (per)


def main():
  if len(sys.argv) != 3:
    print 'USAGE: ./trees.py <file to read> <file to write>\ne.g.: ./trees.py trees.txt varcount.csv'
    sys.exit(1)

  filename = sys.argv[1]
  write_file = sys.argv[2]
  dict_file(filename, write_file)

  sys.exit(1)

if __name__ == '__main__':
  main() 
